#include <stdio.h>
#define n1 1700
#define n2  740
char head[36][80];
unsigned char c[n2][n1];

FILE *fp;
main(int ac,char **av)
{
  int i,j,k;
  int ch[4];
  int ch1[10]={1186,1167,1166,1179,1169,101,1184,1169,1184,1184}; // UBAND SDSS
  int ch2[7]={351,344,4839,3560,2240,2354,1828};  // S L star mi duo fen bu
  if(ac<2){ printf("\n\t show SL status ******\n");
            printf("\n\t Usage: dd3 !\n\n");
            exit(0);
  }
  fp=fopen("dd2.fit","rb");   // max value: 202
  fread(head,36,80,fp);  fread(c,n1,n2,fp); fclose(fp);
  k=0; for(j=50;j<n2;j++)for(i=0;i<n1;i++)if(c[j][i]>k)k=c[j][i];
  printf("max value: %d\n",k);
  k=255-k; for(j=50;j<n2;j++)for(i=0;i<n1;i++)if(c[j][i])c[j][i]+=k;
  fp=fopen("Usl.fit","wb"); 
  xchinese(c,n1,54,600,ch1,10,1,0,-8);      // UBAND
  xchinese(c,n1,48,550,ch2,7,1,0,0);       // SL
  
  for(i=29,j=0;i>=21;i--,j++){ ch[2]=203;
    k=i; if(k>=24)k-=24; ch[0]=k/10+1149; ch[1]=k%10+1149; 
    xchinese(c,n1,10+j*200,10,ch,3,1,0,-8);
    xchinese(c,n1,10+j*200,700,ch,3,1,0,-8);
  }  
  for(i=-10;i<=30;i+=10){ ch[0]=1144; ch[3]=1361;
    j=i; if(j<0){ j=-j; ch[0]=1146; }
    ch[1]=j/10+1149; ch[2]=j%10+1149; 
    xchinese(c,n1,0,i*15+210,ch,4,1,0,-12);
    xchinese(c,n1,1650,i*15+210,ch,4,1,0,-12);
  }  
  fwrite(head,36,80,fp);  fwrite(c,n1,n2,fp); fclose(fp);
}

int open_han24=0;
FILE *fhan24;
unsigned char h24[8178][72],b24[24][24];
t_ch_24(ii,b24)
int ii;
unsigned char b24[24][24];
{
  int i,j,k,b;
  unsigned char *p;
  k=ii%100; if(k>94 || k==0)return(0);
  k+=(ii/100-1)*94; if(k<0 || k>8178)return(0);
  p=h24[k-1];
  for(j=0;j<24;j++)for(i=1;i<=3;i++){ b=*p++; 
    for(k=1;k<=8;k++){ b24[23-j][i*8-k]=b%2; b/=2; }
  }
}

xchinese(map,m1,x,y,ch,cn,j1,j2,j3)
int m1,x,y,cn,*ch,j1,j2,j3;
unsigned char map[][m1];
// x,y position  ! world coordination
// ch(n)         ! n chinese_char. 
// j1            ! 1~6, size
// j2            ! 0, 90, -90, direct
// j3            ! gap
{
  int i,j,k,l;
  if(open_han24==0){ open_han24=1;
    fhan24=fopen("/vega2/pgplot/han.24","rb");
    if(fhan24==0){ printf(" han.24 not found!\n"); exit(0); }
    fread(h24,8178,72,fhan24); fclose(fhan24);
  }
  for(i=0;i<cn;i++){
    t_ch_24(ch[i],b24);
    l=x+i*(24+j3);   
    for(j=0;j<24;j++)for(k=0;k<24;k++)if(b24[j][k])map[j+y][k+l]=255;
  }
}
