#include <stdio.h>
#include <math.h>
#define m 1000000
double v[m],x[m],y[m],z[m];    // z[] equal 4 short
FILE *fp;
double pi,cx,cy;
struct { double v,x,y,z;} u;
main(int ac,char **av)
{
  int i,j=0,k,n; 
  char f1[9];
  if(ac<2){ printf("\n\tg1 N05a  (max_m:%d)\n\n",m); exit(0); }
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  strcpy(f1,"u1/"); strcat(f1,av[1]);
  fp=fopen(f1,"rb");                 // from uband1.txt
  if(fp==0){ printf("%s not found!\n",f1); exit(0); }
l10:
  fread(&u,1,32,fp); if(feof(fp))goto l20;
  v[j]=u.v; x[j]=u.x;  y[j]=u.y; z[j]=u.z; j++;
  goto l10;
l20:
  fclose(fp);
  strcpy(f1,"u2/"); strcat(f1,av[1]);
  fp=fopen(f1,"rb");                 // from uband1.txt
  if(fp==0){ printf("%s not found!\n",f1); exit(0); }
l30:
  fread(&u,1,32,fp); if(feof(fp))goto l40;
  v[j]=u.v; x[j]=u.x;  y[j]=u.y; z[j]=u.z; j++;
  goto l30;
l40:
  fclose(fp);  
  n=j;
  printf("*****total:  %d\n",n);

l50:
  sortd2(v,x,y,z,n); 
  fp=fopen(av[1],"wb");
  for(i=0;i<n;i++){ 
    u.v=v[i]; u.x=x[i]; u.y=y[i]; u.z=z[i];   
    fwrite(&u,1,32,fp);
  }
  fclose(fp);
}

sortd2(v,x,y,z,n)
int n; double *v,*x,*y,*z;
{
  int i,j,k=2,ii,ifin;
  double vv,xx,yy,zz;
  while(k<n)k*=2;
  k=(3*k)/4-1; if(n<k)k=n;
l20:
  k/=2;        ifin=n-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(x[i]<=x[j])continue;
    vv=v[j]; xx=x[j]; yy=y[j]; zz=z[j];
l40:
    v[j]=v[i]; x[j]=x[i]; y[j]=y[i]; z[j]=z[i];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(x[i]>xx)goto l40;
l60:
    v[j]=vv; x[j]=xx; y[j]=yy; z[j]=zz;
  }
  if(k>1)goto l20;
}
